var canvas, context;
var gImage;
var WIDTH, HEIGHT;
var frameRate = 5;
var refreshCount = 0;
var battery;
var currentFrame;
var TIMELINE_MAX_VALUE = 24 * 60 * 60 * frameRate;
var dayOfWeek = ["Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"];
var dayOfWeekFull = ["Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"];
var monthStr = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];
var monthStrFull = ["January", "Febuary", "March", "April", "May", "Jun", "July", "August", "September", "October", "November", "December"];
var maximumDays = [31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
var imgimg11298png = new Image();
var imgweekbg02png = new Image();
var imgbackgearbgpng = new Image();
var imgimg1438png = new Image();
var imgimg1448png = new Image();
var imgimg1438png = new Image();
var imgimg1460png = new Image();
var imgmoonppng = new Image();
var imgbatbg004png = new Image();
var imgdigipng = new Image();
var imgbg005png = new Image();
var imgtimedatebgbox02png = new Image();
var imgimg6719png = new Image();
var imgimg6721png = new Image();
var imgimg6723png = new Image();

window.requestAnimationFrame ||
    window.webkitRequestAnimationFrame ||
    window.mozRequestAnimationFrame ||
    window.oRequestAnimationFrame ||
    window.msRequestAnimationFrame ||
    function (/* function */ callback) {
        'use strict';
        window.setTimeout(callback, 1000 / frameRate);
    };

function getDate() {
    'use strict';

    var date;
    try {
        date = tizen.time.getCurrentDateTime();
    } catch (err) {
        console.error('Error: ', err.message);
        date = new Date();
    }

    return date;
}

function findByValue(isTime, array, value) {
    if (isTime) {
        if (value === TIMELINE_MAX_VALUE) {
            value = 0;
        }

        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] > value) {
                return true;
            }
        }
    } else {
        for (var i = 0; i<array.length; i++) {
            if (array[i][0] <= value && array[i][1] >= value) {
                return true;
            }
        }
    }

    return false;
}

function refresh() {
    'use strict';
    //Erase the previous time
    context.clearRect(0, 0, context.canvas.width, context.canvas.height);

    //Import the current time
    var date = getDate();
    var hours = date.getHours();
    var minutes = date.getMinutes();
    var seconds = date.getSeconds();
    var hour = hours + minutes / 60;
    var minute = minutes + seconds / 60;
    var milliseconds = seconds + date.getMilliseconds()/1000.0;
    var frame = parseInt(date.getMilliseconds()/(1000/frameRate));
    var angle;
    var text;
    var extent;
    var nextX;

    hours = hours > 12 ? hours - 12 : hours;
    currentFrame = (date.getHours() * frameRate * 60 * 60) + (minutes * frameRate * 60) + (seconds * frameRate) + frame;
    context.save();

    imgimg11298png.src = ".img11298.png";
    context.drawImage(imgimg11298png, 168, 171, 137, 137);
    context.restore();
    context.save();

    var Hand1Condition= [[0, 100]];
    if (findByValue(false, Hand1Condition, Math.floor(battery.level*100))) {
        angle = (994.299988 + ((1174.300049 - 994.299988) * ((date.getDay() + 1 - 1.000000) / (8.000000 - 1.000000))))*Math.PI/180;
        context.translate(249, 266);
        context.rotate(angle);
        imgweekbg02png.src = "weekbg02.png";
        context.drawImage(imgweekbg02png, -35, -182, 70, 364);
        context.restore();
        context.save();
    }

    imgbackgearbgpng.src = "backgearbg.png";
    context.globalAlpha = 0.6
    context.drawImage(imgbackgearbgpng, -15, 276, 399, 83);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(118, 274);
    context.rotate(angle);
    imgimg1438png.src = ".img1438.png";
    context.drawImage(imgimg1438png, -49, -49, 98, 98);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(118, 275);
    context.rotate(angle);
    imgimg1448png.src = ".img1448.png";
    context.drawImage(imgimg1448png, -40, -40, 80, 80);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(191, 333);
    context.rotate(angle);
    imgimg1438png.src = ".img1438.png";
    context.drawImage(imgimg1438png, -43, -43, 86, 86);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(191, 333);
    context.rotate(angle);
    imgimg1460png.src = ".img1460.png";
    context.drawImage(imgimg1460png, -33, -33, 66, 66);
    context.restore();
    context.save();

    angle = (180.000000 + ((540.000000 - 180.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(236, 247);
    context.rotate(angle);
    imgmoonppng.src = "moonp.png";
    context.drawImage(imgmoonppng, -51, -51, 102, 102);
    context.restore();
    context.save();

    var Hand7Condition= [[0, 100]];
    if (findByValue(false, Hand7Condition, Math.floor(battery.level*100))) {
        angle = (-509.000000 + ((-734.000000 - -509.000000) * ((Math.floor(battery.level*100) - 0.000000) / (150.000000 - 0.000000))))*Math.PI/180;
        context.translate(263, 108);
        context.rotate(angle);
        imgbatbg004png.src = "batbg004.png";
        context.drawImage(imgbatbg004png, -70, -70, 140, 140);
        context.restore();
        context.save();
    }

    imgdigipng.src = "digi.png";
    context.drawImage(imgdigipng, 37, 73, 156, 78);
    context.restore();
    context.save();

    imgbg005png.src = "bg005.png";
    context.drawImage(imgbg005png, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "SUN";
    context.fillText(text, 157, 260);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "MON";
    context.fillText(text, 158, 220);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "tue";
    context.fillText(text, 190, 185);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "wed";
    context.fillText(text, 238, 176);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "THU";
    context.fillText(text, 286, 189);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "fri";
    context.fillText(text, 307, 219);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "sat";
    context.fillText(text, 314, 249);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "SUN";
    context.fillText(text, 156, 259);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "MON";
    context.fillText(text, 157, 219);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "tue";
    context.fillText(text, 189, 184);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "wed";
    context.fillText(text, 237, 175);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "THU";
    context.fillText(text, 285, 188);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "fri";
    context.fillText(text, 306, 218);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "12px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "sat";
    context.fillText(text, 313, 248);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "32px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "12";
    context.fillText(text, 181, 37);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "32px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "12";
    context.fillText(text, 180, 36);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "32px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "3";
    context.fillText(text, 325, 181);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "32px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "3";
    context.fillText(text, 324, 180);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "32px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "9";
    context.fillText(text, 37, 181);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "32px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "9";
    context.fillText(text, 36, 180);
    context.restore();
    context.save();

    imgtimedatebgbox02png.src = "timedatebgbox02.png";
    context.globalAlpha = 0.6
    context.drawImage(imgtimedatebgbox02png, 76, 255, 40, 40);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px alarmclock";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = "88";
    context.fillText(text, 97, 277);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px alarmclock";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = ((date.getDate()<10) ? "0"+date.getDate() : date.getDate().toString());
    context.fillText(text, 97, 277);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "0";
    context.fillText(text, 307, 139);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "0";
    context.fillText(text, 306, 138);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "100";
    context.fillText(text, 238, 66);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "100";
    context.fillText(text, 237, 65);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "steps";
    context.fillText(text, 118, 133);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "steps";
    context.fillText(text, 117, 132);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px alarmclock";
    context.textAlign = "right";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "Text";
    context.fillText(text, 153, 111);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px alarmclock";
    context.textAlign = "right";
    context.textBaseline="middle";
    context.fillStyle = "#000000";
    text = "88888";
    context.fillText(text, 153, 111);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px alarmclock";
    context.textAlign = "right";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = "888";
    context.fillText(text, 258, 264);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "24px alarmclock";
    context.textAlign = "right";
    context.textBaseline="middle";
    context.fillStyle = "#FFFFFF";
    text = "Text";
    context.fillText(text, 258, 264);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#444444";
    text = "bpm";
    context.fillText(text, 237, 283);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "bpm";
    context.fillText(text, 236, 282);
    context.restore();
    context.save();

    gImage.src = "Merged_index.png";
    context.drawImage(gImage, 0, 0, 360, 360);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "14px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "series";
    context.fillText(text, 97, 174);
    context.restore();
    context.save();

    context.beginPath();
    context.font = "18px ElementalEnd";
    context.textAlign = "center";
    context.textBaseline="middle";
    context.fillStyle = "#111111";
    text = "cp-13";
    context.fillText(text, 97, 187);
    context.restore();
    context.save();

    angle = (0.000000 + ((720.000000 - 0.000000) * ((hour - 0.000000) / (24.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg6719png.src = ".img6719.png";
    context.drawImage(imgimg6719png, -206, -206, 412, 412);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((minute - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg6721png.src = ".img6721.png";
    context.drawImage(imgimg6721png, -206, -206, 412, 412);
    context.restore();
    context.save();

    angle = (0.000000 + ((360.000000 - 0.000000) * ((milliseconds - 0.000000) / (60.000000 - 0.000000))))*Math.PI/180;
    context.translate(180, 180);
    context.rotate(angle);
    imgimg6723png.src = ".img6723.png";
    context.drawImage(imgimg6723png, -206, -206, 412, 412);
    context.restore();
    context.save();

    context.restore();
    window.requestAnimationFrame(refresh);
    refreshCount++;
}

window.onload = function () {
    'use strict';
    canvas = document.getElementById('clock');
    console.log('onload called');
    context = canvas.getContext('2d');

    canvas.width = document.width;
    canvas.height = document.height;

    WIDTH = document.width;
    HEIGHT = document.height;

    gImage = new Image();

    battery = navigator.battery || navigator.webkitBattery || navigator.mozBattery;

    //add eventListener for tizenhwkey
    window.addEventListener('tizenhwkey', function (e) {
        if (e.keyName == 'back') {
            try {
                tizen.application.getCurrentApplication().exit();
            } catch (err) {
                console.log('Error: ', err.message);
            }
        }
    });

    window.requestAnimationFrame(refresh);

};
